// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0

package queries

import (
	"database/sql/driver"
	"fmt"

	"github.com/gofrs/uuid"
	"github.com/jackc/pgx/v5/pgtype"
)

type TransactionlogDirection string

const (
	TransactionlogDirectionIn  TransactionlogDirection = "in"
	TransactionlogDirectionOut TransactionlogDirection = "out"
)

func (e *TransactionlogDirection) Scan(src interface{}) error {
	switch s := src.(type) {
	case []byte:
		*e = TransactionlogDirection(s)
	case string:
		*e = TransactionlogDirection(s)
	default:
		return fmt.Errorf("unsupported scan type for TransactionlogDirection: %T", src)
	}
	return nil
}

type NullTransactionlogDirection struct {
	TransactionlogDirection TransactionlogDirection
	Valid                   bool // Valid is true if TransactionlogDirection is not NULL
}

// Scan implements the Scanner interface.
func (ns *NullTransactionlogDirection) Scan(value interface{}) error {
	if value == nil {
		ns.TransactionlogDirection, ns.Valid = "", false
		return nil
	}
	ns.Valid = true
	return ns.TransactionlogDirection.Scan(value)
}

// Value implements the driver Valuer interface.
func (ns NullTransactionlogDirection) Value() (driver.Value, error) {
	if !ns.Valid {
		return nil, nil
	}
	return string(ns.TransactionlogDirection), nil
}

type TransactionlogMetadatum struct {
	ID            uuid.UUID
	TransactionID uuid.UUID
	Direction     TransactionlogDirection
	GroupID       string
	Metadata      []byte
}

type TransactionlogRecord struct {
	TransactionID                uuid.UUID
	GroupID                      string
	GrantHash                    string
	Direction                    TransactionlogDirection
	ServiceName                  string
	SrcOutwayPeerID              pgtype.Text
	DelegatedSrcOutwayPeerID     pgtype.Text
	DelegatedSrcDelegatorPeerID  pgtype.Text
	DestServicePeerID            pgtype.Text
	DelegatedDestServicePeerID   pgtype.Text
	DelegatedDestDelegatorPeerID pgtype.Text
	CreatedAt                    pgtype.Timestamptz
}
